<template>
 <div class="main-contain">
    <div class="position">
      <bread-crumb :crumbs='crumbs'></bread-crumb>
    </div>
    <div class="app-container" id="outcome-indicators-query">
      <el-tabs v-model="tabActiveName" @tab-click="handleTabClick" style="margin-bottom:10px">
          <el-tab-pane label="指标控制" name="control"></el-tab-pane>
          <el-tab-pane label="指标查询" name="query"></el-tab-pane>
      </el-tabs>

      <div class="cell clearfix">
        <el-form :inline="true" :model="listQuery" >
          <el-form-item label="">
            <el-input v-model="listQuery.search" placeholder="姓名/透析号"></el-input>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="onSearch"  icon="el-icon-search">搜索</el-button>
          </el-form-item>
        </el-form>
      </div>
      <div class="cell clearfix">
        <label class="title">
          <span class="name">日期查询</span> :
        </label>
        <el-date-picker
          v-model="listQuery.start_time"
          prefix-icon="el-icon-date"
          @change="changeTime"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
        ></el-date-picker>
        <span class>-</span>
        <el-date-picker
          v-model="listQuery.end_time"
          prefix-icon="el-icon-date"
          @change="changeTime"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
        ></el-date-picker>
      </div>

      <div class="cell clearfix">
        <label class="title">
          <span class="name">检验项目</span> :
        </label>
        <el-select v-model="listQuery.project_id" placeholder="请选择" @change="changeModel()">
          <el-option v-for="item in projectOptions" :key="item.project_id" :label="item.project_name" :value="item.project_id"></el-option>
        </el-select>
      </div>

      <div class="cqd-dataTitle">统计表</div>
      <el-table
        ref="multipleTable"
        :data="tableData"
        id="oictable"
        border
        fit
        highlight-current-row
        style="width: 100%;margin-top: 10px;"
        :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)'}"
      >
        
        <el-table-column fixed label="透析号" width="80" property="patient_id" align="center">
          <template slot-scope="scope"><span>{{getPatientDialysisNo(scope.row.patient_id)}}</span></template>
        </el-table-column>
        <el-table-column fixed label="姓名" width="100" property="patient_id" align="center">
          <template slot-scope="scope"><span>{{getPatientName(scope.row.patient_id)}}</span></template>
        </el-table-column>
        <el-table-column fixed label="性别" width="100" property="patient_id" align="center">
          <template slot-scope="scope"><span>{{getPatientGender(scope.row.patient_id)}}</span></template>
        </el-table-column>
        
        <el-table-column fixed label="检查日期" width="100" property="inspect_date" align="center">
          <template slot-scope="scope"><span>{{getTime(scope.row.inspect_date, '{y}{m}{d}')}}</span></template>
        </el-table-column>
        
        <el-table-column :label="reference.item_name+'//'+reference.unit" min-width="210" align="center"  v-for="(reference, index) in activeReferences" :key="index"  :render-header="renderheader">
          <template slot-scope="scope"><span>{{getItemVulue(reference.project_id, reference.id, scope.row)}}</span></template>
        </el-table-column>
      </el-table>

      <!-- <pagi-nation title="分页"></pagi-nation> -->

      <el-pagination
        align="right"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page="listQuery.pate"
        :page-sizes="[10, 20, 50, 100]"
        :page-size="10"
        background
        style="margin-top:20px;"
        layout="total, sizes, prev, pager, next, jumper"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>


<script>
import { GetOIQData  } from "@/api/qcd";
import {uParseTime} from "@/utils/tools";
import BreadCrumb from "@/xt_pages/components/bread-crumb";
export default {
  name: "dialysisTotal",
  data() {
    return {
      crumbs:[
        {path:false, name:'科室质控'},
        {path:false, name:'结果指标'},
        {path:false, name:'指标查询'},
      ],
      tabActiveName:'query',
      total: 0,
      projectOptions:{},
      patientMap:{},
      listQuery: {
        start_time: "",
        end_time: "",
        page: 1,
        limit: 10,
        project_id:'',
      },
      routineBloodShowItem:{1:1,17:17,18:18,19:19,2:2,3:3,24:24},
      tableData: [],
      references:[],
      lapsetoType: 0,
      lapsetoState: [
        { value: 0, label: "全部", source: 0, lapseto: 0 },
        { value: 1, label: "转出", source: 0, lapseto: 2 },
        { value: 2, label: "留治", source: 0, lapseto: 1 }
      ],
    };
  },
  created() {

    var nowDate = new Date();
    var nowYear = nowDate.getFullYear();
    var nowMonth = nowDate.getMonth() + 1;
    var nowDay = nowDate.getDate();
    this.listQuery.end_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
    nowDate.setMonth(nowDate.getMonth() - 3);
    nowYear = nowDate.getFullYear();
    nowMonth = nowDate.getMonth() + 1;
    nowDay = nowDate.getDate();
    this.listQuery.start_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
    this.getList();
  },
  methods: {
    getList() {
      GetOIQData(this.listQuery).then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg);
          return false;
        } else {
          this.tableData = [];
          this.total = response.data.data.total;
        
          var references = response.data.data.references;
          this.references = response.data.data.references;
          this.projectOptions = {};
          for (const index in references) {
            if (!(references[index].project_id in this.projectOptions)) {
              this.$set(this.projectOptions, references[index].project_id, {project_id:references[index].project_id, project_name:references[index].project_name}); 
            }
            if (!('children' in this.projectOptions[references[index].project_id])) {
                this.projectOptions[references[index].project_id]['children'] = [];
            }
            this.projectOptions[references[index].project_id]['children'].push(references[index]);
          }
          if(this.listQuery.project_id == '') {
            this.listQuery.project_id = references[0].project_id;
          }

          var patients = response.data.data.patients;
          for (const index in patients) {
            if (patients[index].id in this.patientMap) {
              continue;  
            }
            this.$set(this.patientMap, patients[index].id, patients[index]);
          }

          var temInspections = {};
          var inspections = response.data.data.inspections;
          
          for (const index in inspections) {
            var key = inspections[index].inspect_date + '_' + inspections[index].patient_id;
            if (!(key in temInspections)) {
              temInspections[key] = {patient_id:inspections[index].patient_id, inspect_date:inspections[index].inspect_date, items:{}};
            }
            var itemKey = inspections[index].project_id + '_' + inspections[index].item_id;
            
            temInspections[key].items[itemKey] = inspections[index];
          }
          for (const key in temInspections) {
              this.tableData.push(temInspections[key]);
          }
        }
      });
    },
    changeTime() {
      this.getList();
    },
    onSearch(){
      this.getList();
    },
    changeModel() {
      this.getList();
    },
    handleSizeChange(val) {
      this.listQuery.limit = val;
      this.getList();
    },
    handleCurrentChange(val) {
      this.listQuery.page = val;
      this.getList();
    },
    getTime(value, temp) {
        if (value != undefined) {
          return uParseTime(value, temp)
        }
        return ""
    },
    getProjectName(id) {
      return (id in this.projectOptions) ? this.projectOptions[id].project_name:'';
    },
    getPatientName(id) {
      return (id in this.patientMap) ? this.patientMap[id].name:'';
    },
    getPatientGender(id) {
      var gender = (id in this.patientMap) ? this.patientMap[id].gender:0;
      if (gender == 1) {
        return '男';
      } else if(gender == 2) {
        return '女';
      }
      return '';
    },
    getPatientDialysisNo(id) {
      return (id in this.patientMap) ? this.patientMap[id].dialysis_no:'';
    },
    getItemVulue(project_id, item_id, row) {
        var key = project_id + '_' + item_id;
        return (typeof(row.items) !== 'undefined' && (key in row.items)) ? row.items[key].inspect_value:'';
    },
    showTableColumn(reference) {
        if(this.listQuery.project_id == '') {
            return true;
        }else if(reference.project_id == this.listQuery.project_id) {
            if(this.listQuery.project_id==1 && !(reference.id in this.routineBloodShowItem)) {
              return false;
            }else {
              return true;
            }
        }else {
                return false;
            }
    },
    renderheader(h, { column, $index }) {
        return h('span', {}, [
            h('span', {}, column.label.split('//')[0]),
            h('br'),
            h('span', {}, column.label.split('//')[1])
        ])
    },
    handleTabClick(tab, event) {
        if (this.tabActiveName == 'control') {
            this.$router.push({ path: "/qcd/outcomeIndicators/control" });
        }

    }
  },
  computed:{
    activeReferences:function(){
      var references = [];
      for (const index in this.references) {
        if (this.listQuery.project_id == '' || (this.references[index].project_id == this.listQuery.project_id && (this.listQuery.project_id!=1 || this.references[index].id in this.routineBloodShowItem) )) {
          references.push(this.references[index]);
        }
      }
      return references;
    }
  },
  components: {
    BreadCrumb
  }
};
</script>
<style>
#oictable ::-webkit-scrollbar {
  height: 15px;
}
#outcome-indicators-query .el-form-item {
    margin-bottom: 0px !important;
}
</style>


<style rel="stylesheet/scss" lang="scss" scoped>
.app-container {
//   margin: 20px;
  font-size: 15px;
  .filter-container {
    padding-bottom: 5px;
  }
  .cqd-dataTitle{
    color: #303133;
    font-size: 14px;
    border-bottom: 2px #E4E7ED solid;
    height: 36px;
    line-height: 36px;
    margin: 0 0 25px 0;
    position: relative;
  }
  .cqd-dataTitle::before {
      position: absolute;
      left: 0;
      bottom: -2px;
      content: "";
      width: 42px;
      height: 2px;
      background: #409eff;
  }
  .search-component {
    width: 500px;
    .searchBox {
      width: 300px;
      height: 36px;
      line-height: 36px;
      padding-left: 15px;
      border: 1px #dcdfe6 solid;
      border-right: none;
      outline: none;
      float: left;
      border-radius: 6px 0 0 6px;
      font-size: 14px;
      color: #333;
      background: #fff;
      box-shadow: 3px 3px 4px rgba(135, 135, 135, 0.05);
    }
    .searchBtn {
      background-color: #409eff;
      color: #fff;
      font-size: 15px;
      text-align: center;
      height: 36px;
      line-height: 36px;
      float: left;
      outline: none;
      width: 70px;
      border: none;
      border-radius: 0 6px 6px 0;
      font-family: "Microsoft Yahei";
      cursor: pointer;
    }
  }
  .amount {
    font-weight: normal;
    padding: 10px 0 0 0;
    color: #606266;
    font-size: 14px;
    span {
      color: #ef2525;
      font-family: "Arial";
      padding: 0 2px;
    }
  }
}
</style>